version: '3'

volumes:
  diesos_local_postgres_data: {}
  diesos_local_postgres_data_backups: {}
  diesos-media:

services:
  django: &django
    build:
      context: .
      dockerfile: ./compose/local/django/Dockerfile
    image: diesos_local_django
    container_name: diesos_local_django
    depends_on:
      - postgres
      - redis
      - mailhog
    volumes:
      - .:/app:z
      - diesos-media:/media
      
    env_file:
      - ./.envs/.local/.django
      - ./.envs/.local/.postgres
    ports:
      - "8000:8000"
    command: /start

  postgres:
    build:
      context: .
      dockerfile: ./compose/production/postgres/Dockerfile
    image: diesos_production_postgres
    container_name: diesos_local_postgres
    volumes:
      - diesos_local_postgres_data:/var/lib/postgresql/data
      - diesos_local_postgres_data_backups:/backups
    env_file:
      - ./.envs/.local/.postgres
    ports:
      - "5432:5432"

  docs:
    image: diesos_local_docs
    container_name: diesos_local_docs
    build:
      context: .
      dockerfile: ./compose/local/docs/Dockerfile
    env_file:
      - ./.envs/.local/.django
    volumes:
      - ./docs:/docs:z
      - ./config:/app/config:z
      - ./diesos:/app/diesos:z
    ports:
      - "9000:9000"
    command: /start-docs

  mailhog:
    image: mailhog/mailhog:v1.0.0
    container_name: diesos_local_mailhog
    ports:
      - "8025:8025"

  redis:
    image: redis:6
    container_name: diesos_local_redis

  celeryworker:
    <<: *django
    image: diesos_local_celeryworker
    container_name: diesos_local_celeryworker
    depends_on:
      - redis
      - postgres
      - mailhog
    volumes:
    - diesos-media:/media
    ports: []
    command: /start-celeryworker

  celerybeat:
    <<: *django
    image: diesos_local_celerybeat
    container_name: diesos_local_celerybeat
    depends_on:
      - redis
      - postgres
      - mailhog
    volumes:
    - diesos-media:/media
    ports: []
    command: /start-celerybeat

  flower:
    <<: *django
    image: diesos_local_flower
    container_name: diesos_local_flower
    volumes:
    - diesos-media:/media
    ports:
      - "5555:5555"
    command: /start-flower
